#include <stdio.h>
#include "memory_arena.h"
#include "sc_queue.h"
#include <assert.h>

int main(void) {
    assert(mem_arena_init(4));
    mem_arena_print();

    void* buf = mem_arena_malloc(64);
    mem_arena_print();
    mem_arena_free(buf);
    mem_arena_print();

    struct sc_queue_32 queue;
    sc_queue_init(&queue);

    sc_queue_add_last(&queue, 1);
    sc_queue_add_last(&queue, 2);
    sc_queue_add_last(&queue, 3);

    mem_arena_print();

    sc_queue_term(&queue);

    mem_arena_print();
    mem_arena_deinit();
    return 0;
}
